function val = Ghp_p3(xi,eta,theta)

gamma = 5.608;
delta = 0;

zeta = gamma*theta + delta;

m = size(xi,1);
n = size(xi,2);

l0xi = 0.5*(1-xi);
l0eta = 0.5*(1-eta);

lmbdxi0  = -sqrt(3) * ones(m,n);  % -sqrt(6) * ones(m,n); 
lmbdxi1  = -sqrt(5)*xi;          % -sqrt(10)*xi;

lmbdeta0 = -sqrt(3) * ones(m,n); 
lmbdeta1 = -sqrt(5)*eta;

mu0 = 1/10;   % 1/5;
mu1 = 1/42;   % 1/21;

b0 = -sqrt(3)/12;   % -sqrt(6)/12;
b1 = -sqrt(5)/60;   % -sqrt(10)/60;


D10 = 1 ./ (1 + zeta * mu0);  % 1 ./ (2 + zeta * mu0);
D11 = 1 ./ (1 + zeta * mu1);  % 1 ./ (2 + zeta * mu1);

r = 1 + 1/3*zeta - zeta.*zeta.*(b0.*b0.*D10 + b1.*b1.*D11);

% Since delata=0 we have to cancel one theta in the expression for s0
% to avoid division by zero.
s0 = 3 ./ (3*r + 3*theta + gamma);

%  %----- CHECK  ----
%  s0orig = 1 ./ (r + theta + zeta./(3*theta));
%  if abs(s0-s0orig) > 1e-12
%    error('Check of s0 failed by %g !', s0-s0orig);
%  end
%  %----- END CHECK --------

psixi  = 1 - zeta.*l0xi  .* (b0.*D10.*lmbdxi0  + b1.*D11.*lmbdxi1);
psieta = 1 - zeta.*l0eta .* (b0.*D10.*lmbdeta0 + b1.*D11.*lmbdeta1);

Gbub = l0xi.*l0eta .* (D10.*lmbdxi0.*lmbdeta0 + D11.*lmbdxi1.*lmbdeta1);

val = s0.*psixi.*psieta + Gbub;

