function val = Ghp_p5(xi,eta,theta)

gamma = 7.799;
delta = 0;

zeta = gamma*theta + delta;

m = size(xi,1);
n = size(xi,2);

l0xi = 0.5*(1-xi);
l0eta = 0.5*(1-eta);

lmbdxi0  = (1/9576)*sqrt(9690-840*sqrt(7)*sqrt(19))*(19*sqrt(7)+14*sqrt(19)) * (-21*xi.^2+49+4*sqrt(7)*sqrt(19));
lmbdxi1  = -(1/264)*sqrt(42)*(-4+sqrt(5)) * xi.*(-33*xi.^2+37+12*sqrt(5));
lmbdxi2  = (1/9576)*sqrt(30)*sqrt(323+28*sqrt(7)*sqrt(19))*(19*sqrt(7)-14*sqrt(19)) * (21*xi.^2-49+4*sqrt(7)*sqrt(19));
lmbdxi3  = -(1/264)*sqrt(42)*(sqrt(5)+4) * xi.*(33*xi.^2-37+12*sqrt(5));

lmbdeta0  = (1/9576)*sqrt(9690-840*sqrt(7)*sqrt(19))*(19*sqrt(7)+14*sqrt(19)) * (-21*eta.^2+49+4*sqrt(7)*sqrt(19));
lmbdeta1  = -(1/264)*sqrt(42)*(-4+sqrt(5)) * eta.*(-33*eta.^2+37+12*sqrt(5));
lmbdeta2  = (1/9576)*sqrt(30)*sqrt(323+28*sqrt(7)*sqrt(19))*(19*sqrt(7)-14*sqrt(19)) * (21*eta.^2-49+4*sqrt(7)*sqrt(19));
lmbdeta3  = -(1/264)*sqrt(42)*(sqrt(5)+4) * eta.*(33*eta.^2-37+12*sqrt(5));

mu0 = 1/(56-4*sqrt(133));
mu1 = 1/(120-36*sqrt(5));
mu2 = 1/(56+4*sqrt(133));
mu3 = 1/(120+36*sqrt(5));

b0 = -(1/28)*sqrt(7)*(-14+sqrt(7)*sqrt(19))/sqrt(9690-840*sqrt(7)*sqrt(19));
b1 = -(1/2520)*sqrt(42)*(-10+3*sqrt(5))/(sqrt(5)-2);
b2 = -(1/840)*sqrt(30)*sqrt(7)*(14+sqrt(7)*sqrt(19))/sqrt(323+28*sqrt(7)*sqrt(19));
b3 = -(1/2520)*sqrt(42)*(10+3*sqrt(5))/(2+sqrt(5));

D10 = 1 ./ (1 + zeta * mu0);
D11 = 1 ./ (1 + zeta * mu1);
D12 = 1 ./ (1 + zeta * mu2);
D13 = 1 ./ (1 + zeta * mu3);

r = 1 + 1/3*zeta - zeta.*zeta.*(b0.*b0.*D10 + b1.*b1.*D11 + b2.*b2.*D12 + b3.*b3.*D13);

% If delta=0 we have to cancel one theta in the expression for s0
% to avoid division by zero.
s0 = 3 ./ (3*r + 3*theta + gamma);

%  %----- CHECK  ----
%  s0orig = 1 ./ (r + theta + zeta./(3*theta));
%  if abs(s0-s0orig) > 1e-12
%    error('Check of s0 failed by %g !', s0-s0orig);
%  end
%  %----- END CHECK --------

psixi  = 1 - zeta.*l0xi  .* (b0.*D10.*lmbdxi0  + b1.*D11.*lmbdxi1  + b2.*D12.*lmbdxi2  + b3.*D13.*lmbdxi3);
psieta = 1 - zeta.*l0eta .* (b0.*D10.*lmbdeta0 + b1.*D11.*lmbdeta1 + b2.*D12.*lmbdeta2 + b3.*D13.*lmbdeta3);

Gbub = l0xi.*l0eta .* (D10.*lmbdxi0.*lmbdeta0 + D11.*lmbdxi1.*lmbdeta1 + D12.*lmbdxi2.*lmbdeta2 + D13.*lmbdxi3.*lmbdeta3);

val = s0.*psixi.*psieta + Gbub;

