
% Initialization of IntLab
if (isempty(findstr('intlab', lower(path))))  
  % If 'intlab' is not in path then initialize it, otherwise it is considered as initialized.
  currpath = pwd;
  cd ~/prg/matlab/Intlab_V5.5
  startup;
  cd(currpath)
end

global nntest_stat

for p=3:10

  % some statistics
  nntest_stat{1} = 0; % maximal level
  nntest_stat{2} = 0; % number of calls of nntest_vf
  fid = fopen(['nntest_p' num2str(p) '.log'],'w');
  fprintf(fid,'DMPabs: check of nonnegativity for polynomial degree p=%d.\n\n',p);
  fprintf(    'DMPabs: check of nonnegativity for polynomial degree p=%d.\n\n',p);

  % call the function for correct polynomial degree
  tic
  if (p==3)
  nntest_vf(fid, 1,'', -1,1, -1,1, 0,0.5, @Ghp_p3);
  elseif (p==4)
  nntest_vf(fid, 1,'', -1,1, -1,1, 0,0.5, @Ghp_p4);
  elseif (p==5)
  nntest_vf(fid, 1,'', -1,1, -1,1, 0,0.5, @Ghp_p5);
  elseif (p==6)
  nntest_vf(fid, 1,'', -1,1, -1,1, 0,0.5, @Ghp_p6);
  elseif (p==7)
  nntest_vf(fid, 1,'', -1,1, -1,1, 0,0.5, @Ghp_p7);
  elseif (p==8)
  nntest_vf(fid, 1,'', -1,1, -1,1, 0,0.5, @Ghp_p8);
  elseif (p==9)
  nntest_vf(fid, 1,'', -1,1, -1,1, 0,0.5, @Ghp_p9);
  elseif (p==10)
  nntest_vf(fid, 1,'', -1,1, -1,1, 0,0.5, @Ghp_p10);
  end
  et = toc;
  fclose(fid);

  % print the statisctics
  s = nntest_stat;

  fprintf('Nonnegativity verified.\n');
  fprintf('Elapsed time: %f sec.\n', et);
  fprintf('Maximal level: %d\n', s{1});
  fprintf('Number of calls of nntest_vf: %d\n', s{2});
  fprintf('Number of interval function evaluations: %d\n', s{2}*16*16*16);
  fprintf('\n');

  % save the statisctics to a file 
  fid = fopen(['nntest_p' num2str(p) '_stat.txt'],'w');
  fprintf(fid,'DMPabs: Check of nonnegativity for polynomial degree p=%d.\n',p);
  fprintf(fid,'Nonnegativity verified.\n');
  fprintf(fid,'Elapsed time: %f sec.\n', et);
  fprintf(fid,'Maximal level: %d\n', s{1});
  fprintf(fid,'Number of calls of nntest_vf: %d\n', s{2});
  fprintf(fid,'Number of interval function evaluations: %d\n', s{2}*16*16*16);
  fclose(fid);

end % for p